package org.exoplatform.frameworks.davclient.commands;

import org.exoplatform.frameworks.davclient.Const;
import org.exoplatform.frameworks.davclient.ServerLocation;
import org.w3c.dom.Document;

public class DavMove extends DavCommand {
  
  protected String destinationPath = "";
  
  public DavMove(ServerLocation location) throws Exception {
    super(location);
    commandName = Const.DavCommand.MOVE;
  }
  
  public void setDestinationPath(String destinationPath) {
    this.destinationPath = String.format("http://%s:%s%s%s",
        location.getHost(),
        location.getPort(),
        location.getServletPath(),
        destinationPath);
  }
  
  public int execute() throws Exception {    
    client.setRequestHeader(Const.HttpHeaders.DESTINATION, destinationPath);
    return super.execute();
  }
  
  public void finalExecute() {
  }
  
  public Document toXml(Document xmlDocument) {
    return null;
  }
  
  
  
}
