package org.exoplatform.frameworks.davclient.documents;

import java.util.ArrayList;

import org.apache.commons.logging.Log;
import org.exoplatform.frameworks.davclient.Const;
import org.exoplatform.frameworks.davclient.XmlUtil;
import org.exoplatform.services.log.ExoLogger;
import org.w3c.dom.Document;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

public class Multistatus implements DocumentApi {

  private static Log log = ExoLogger.getLogger("jcr.Multistatus");
  
  protected ArrayList<ResponseDoc> responses = new ArrayList<ResponseDoc>(); 
  
  public boolean initFromDocument(Document document) {
    try {      
      Node documentNode = XmlUtil.getChildNode(document, Const.StreamDocs.MULTISTATUS);
      
      NodeList respNodes = documentNode.getChildNodes();
      for (int i = 0; i < respNodes.getLength(); i++) {
        Node curResponse = respNodes.item(i);
        
        String localName = curResponse.getLocalName();
        String nameSpace = curResponse.getNamespaceURI();
        
        if (localName != null && Const.Dav.NAMESPACE.equals(nameSpace)) {
          ResponseDoc response = new ResponseDoc(curResponse);
          responses.add(response);
        }
        
      }
      
      return true;
    } catch (Exception exc) {
      log.info("Unhandled exception. " + exc.getMessage());
      exc.printStackTrace();
    }
    
    return false;
  }
  
  public ArrayList<ResponseDoc> getResponses() {
    return responses;
  }
  
}
