package org.exoplatform.frameworks.davclient.documents;

import org.exoplatform.frameworks.davclient.Const;
import org.exoplatform.frameworks.davclient.XmlUtil;
import org.exoplatform.frameworks.davclient.properties.PropApi;
import org.exoplatform.frameworks.davclient.properties.PropManager;
import org.w3c.dom.Document;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

public class PropDoc implements DocumentApi {
  
  protected PropApi singleProperty = null;

  public boolean initFromDocument(Document document) {    
    Node documentNode = XmlUtil.getChildNode(document, Const.StreamDocs.PROP);

    NodeList nodes = documentNode.getChildNodes();
    Node propertyNode = null;
    for (int i = 0; i < nodes.getLength(); i++) {
      Node curNode = nodes.item(i);
      if (curNode.getLocalName() != null && 
          Const.Dav.NAMESPACE.equals(curNode.getNamespaceURI())) {
        propertyNode = curNode;
        break;
      }
    }
    
    if (propertyNode == null) {
      return false;
    }
    
    singleProperty = PropManager.getPropertyByNode(propertyNode, Const.HttpStatus.OK_DESCR);
    
    return false;
  }
  
  public PropApi getSingleProperty() {
    return singleProperty;
  }
  
}
