package org.exoplatform.frameworks.davclient.properties;

import org.exoplatform.frameworks.davclient.Const;
import org.w3c.dom.Node;

public class ContentLengthProp extends CommonProp {

  protected int contentLength = 0;

  public ContentLengthProp() {
    this.propertyName = Const.DavProp.GETCONTENTLENGTH;
  }
  
  public boolean init(Node node) {
    if (status != Const.HttpStatus.OK) {
      return false;
    }
    
    String contLen = node.getTextContent();
    contentLength = new Integer(contLen);
    return true;
  }    
  
  public int getContentLength() {
    return contentLength;
  }
  
}
