package org.exoplatform.frameworks.davclient.properties;

import org.exoplatform.frameworks.davclient.Const;
import org.exoplatform.frameworks.davclient.XmlUtil;
import org.w3c.dom.Node;

public class ResourceTypeProp extends CommonProp {

  protected boolean isCollection = true;

  public ResourceTypeProp() {
    this.propertyName = Const.DavProp.RESOURCETYPE;
  }
  
  public boolean init(Node node) {
    if (status != Const.HttpStatus.OK) {
      return false;
    }

    Node collectionNode = XmlUtil.getChildNode(node, Const.DavProp.COLLECTION);
    if (collectionNode == null) {
      isCollection = false;
    }
    
    return true;
  }  
  
  public boolean isCollection() {
    return isCollection;
  }
  
}
