/**
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 */

package org.exoplatform.services.jcr.dataflow.persistent;

import java.io.IOException;
import java.io.InputStream;

import org.apache.commons.logging.Log;
import org.exoplatform.services.jcr.datamodel.AbstractValueData;
import org.exoplatform.services.jcr.util.io.LazyInputStream;
import org.exoplatform.services.log.ExoLogger;

/**
 * Created by The eXo Platform SARL        .</br>
 * 
 * Immutable PropertyData
 * 
 * @author <a href="mailto:gennady.azarenkov@exoplatform.com">Gennady Azarenkov</a>
 * @version $Id: PersistedValueData.java 8638 2006-09-06 14:19:34Z peterit $
 */

public class PersistedValueData extends AbstractValueData {
  
  private static Log log = ExoLogger.getLogger("jcr.PersistedValueData");
  
  /**
   * Create PersistedValueData with data in bytes array
   */
  public PersistedValueData(final byte[] data, final int orderNumber) {
    super(data, orderNumber);
  }

  /**
   * Create PersistedValueData with in-memory buffer option
   */
  public PersistedValueData(InputStream stream, int orderNumber, boolean inBuffer) throws IOException {
    super(stream, orderNumber, inBuffer);
  }
  
  /**
   * Create PersistedValueData with swap option
   */
  public PersistedValueData(InputStream stream, int orderNumber, String swapFilePath, int minSwapFileSize) throws IOException {
    super(stream, orderNumber, swapFilePath, minSwapFileSize);
  }

  /**
   * Create PersistedValueData with lazy read stream option
   */
  public PersistedValueData(LazyInputStream stream, int orderNumber) throws IOException {
    super(stream, orderNumber);
  }
  
}
