/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.jcr.impl.core;

import javax.jcr.RepositoryException;

import org.exoplatform.services.jcr.datamodel.ItemData;
import org.exoplatform.services.jcr.datamodel.NodeData;
import org.exoplatform.services.jcr.impl.Constants;
import org.exoplatform.services.jcr.impl.core.version.VersionHistoryImpl;
import org.exoplatform.services.jcr.impl.core.version.VersionImpl;

/**
 * Created by The eXo Platform SARL        .
 *
 * @author <a href="mailto:geaz@users.sourceforge.net">Gennady Azarenkov</a>
 * @version $Id: ItemFactory.java 6078 2006-06-08 15:14:03Z peterit $
 * 
 */
class SessionItemFactory {

  private final SessionImpl session;
  
  public SessionItemFactory(SessionImpl session) {
    this.session = session;
  }

  public ItemImpl createItem(ItemData data) throws RepositoryException {
    //ItemData data = state.getData();
    if (data.isNode())
      return createNode((NodeData)data);
    else
      return createProperty(data);
  } 

  private NodeImpl createNode(NodeData data) throws RepositoryException {
    NodeImpl node = new NodeImpl(data, session);
    if (node.isNodeType(Constants.NT_VERSION)) {
      return new VersionImpl(data, session);
    } else if (node.isNodeType(Constants.NT_VERSIONHISTORY))
      return new VersionHistoryImpl(data, session);
    else
      return node;
  }
  
  private PropertyImpl createProperty(ItemData data) throws RepositoryException {
    return new PropertyImpl(data, session);
  }

}
