/**
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 */

package org.exoplatform.services.jcr.impl.core.access;

import javax.jcr.Credentials;
import javax.jcr.LoginException;

import org.exoplatform.services.jcr.access.SystemIdentity;
import org.exoplatform.services.jcr.config.RepositoryEntry;
import org.exoplatform.services.jcr.impl.core.CredentialsImpl;
import org.exoplatform.services.security.SecurityService;

/**
 * Created by The eXo Platform SARL .<br/>
 * 
 * This authenticator uses identity stored in current SessionContainer
 * 
 * @author <a href="mailto:gennady.azarenkov@exoplatform.com">Gennady Azarenkov
 *         </a>
 * @version $Id: PortalAuthenticationPolicy.java 8528 2006-09-04 09:06:54Z geaz $
 */

public class PortalAuthenticationPolicy extends BaseAuthenticationPolicy {
  
//  private static ThreadLocal <Credentials> threadLocal = new ThreadLocal<Credentials>();
  
  private StatefulCredentialsProvider credentialsProvider;
  

  public PortalAuthenticationPolicy(RepositoryEntry config,
      SecurityService securityService, 
      StatefulCredentialsProvider credentialsProvider) {
    super(config, securityService);
    this.credentialsProvider = credentialsProvider;
  }
  
//  public void init(Credentials credentials) {
//    threadLocal.set(credentials);
//  }

  /* (non-Javadoc)
   * @see org.exoplatform.services.jcr.impl.core.access.BaseAuthenticationPolicy#authenticate()
   */
  public Credentials authenticate() throws LoginException {
/*    
    CredentialsImpl thisCredentials;

    // Try to reuse Host's identity
    SessionContainer sessionContainer = SessionContainer.getInstance();
    if (sessionContainer != null) {
      String userId = SessionContainer.getInstance().getRemoteUser();
      
      // Anonimous user
      if (userId == null)
        userId = SystemIdentity.ANONIM;
      
      thisCredentials = new CredentialsImpl(userId, new char[0]);

      log.debug("Repository.login() gets user  " + userId
          + " from SessionContainer");
    } else {
      throw new LoginException(
          "Current User should be authenticated externally but was not.");
    }
    
    return thisCredentials;
*/
    Credentials thisCredentials = credentialsProvider.getCredentials();
    if(thisCredentials == null)
      return new CredentialsImpl(SystemIdentity.ANONIM, new char[0]);
    else
      return thisCredentials;
  }

}
