/**
 * Copyright 2001-2006 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 */

package org.exoplatform.services.jcr.impl.core.access;

import javax.jcr.Credentials;

/**
 * Created by The eXo Platform SARL        .<br/>
 * Class responsible for storing and providing Credentials object
 * 
 * @author exoplatform
 * @version $Id: $
 * @since 1.0.1
 */

public class StatefulCredentialsProvider {
  
  private static ThreadLocal <Credentials> threadLocal = new ThreadLocal<Credentials>();
  
  /**
   * Initializes credentials  
   * @param credentials
   */
  public void init(Credentials credentials) {
    threadLocal.set(credentials);
  }
  
  /**
   * @return stored credentials
   */
  public Credentials getCredentials() {
    return threadLocal.get();
  }
}
