/**
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 */

package org.exoplatform.services.jcr.impl.core.version;

import javax.jcr.Node;
import javax.jcr.Property;
import javax.jcr.RepositoryException;
import javax.jcr.version.OnParentVersionAction;

import org.exoplatform.services.jcr.impl.core.NodeImpl;
import org.exoplatform.services.jcr.impl.core.itemvisitors.NodeCopyVisitor;

public class NodeCopyIgnoredVisitor extends NodeCopyVisitor {

  public NodeCopyIgnoredVisitor(NodeImpl context, boolean keepUUIDs, boolean registerInDataManager) {
    super(context, keepUUIDs, registerInDataManager);
  }
  
  protected void toLog(String message) {
    System.out.println(message);
  }
  
  protected void entering(Property property, int level) throws RepositoryException {

    Node propertyParent = property.getParent();
    if ((property.getDefinition().getOnParentVersion() == OnParentVersionAction.IGNORE && level ==1 ) ||
        (propertyParent.getDefinition().getOnParentVersion() == OnParentVersionAction.IGNORE)) {
      super.entering(property, level);
    } else {
      //toLog("The property: " + property.getPath() + " is not IGNORE");
    }
  }

  protected void entering(Node node, int level) throws RepositoryException {
    
    // for debug
    // if (level == 0) return;
    
    if (node.getDefinition().getOnParentVersion() == OnParentVersionAction.IGNORE) {
      super.entering(node, level);
    } else {
      //toLog("The node: " + node.getPath() + " is not IGNORE");
    }
  }
  
  protected void leaving(Node node, int level) throws RepositoryException {
    if (parents.size()>0) {
      parents.pop();
    }
  }
}