/***************************************************************************
 * Copyright 2001-2006 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.jcr.api.perf;

import java.util.ArrayList;
import java.util.List;

import javax.jcr.Node;

import org.exoplatform.services.jcr.JcrAPIBaseTest;

/**
 * Created by The eXo Platform SARL
 * Author : Peter Nedonosko
 *          peter.nedonosko@exoplatform.com.ua
 * 20.07.2006
 * @version $Id: TestBulkItemsAdd.java 6864 2006-07-20 09:43:44Z peterit $
 */
public class TestBulkItemsAdd extends JcrAPIBaseTest {
  
  public void testNodeAdd() throws Exception {
    Node testRoot = session.getRootNode().addNode("testRoot");
    session.save();
    long startTime = System.currentTimeMillis();
    //int stepIndex = 0;
    int nodesCount = 1000;
    for (int i = 0; i < nodesCount; i++) {
      long addTime = System.currentTimeMillis();
      String nodeName = "_" + i + "node";
      Node n = testRoot.addNode(nodeName);
      log.info("add node " + nodeName + ", " + (System.currentTimeMillis() - addTime) + "ms, " 
          + (System.currentTimeMillis() - startTime) + "ms");
//      if (i - stepIndex >= 1000) {
//        addTime = System.currentTimeMillis();
//        testRoot.save();
//        stepIndex += i;
//        long savePeriod = System.currentTimeMillis() - addTime;
//        log.info("Save part of added nodes, " + savePeriod + "ms");
//      }
    }
    log.info("Nodes added " + nodesCount + ", " + (System.currentTimeMillis() - startTime) + "ms");
    startTime = System.currentTimeMillis();
    testRoot.save();
    log.info("Nodes saved " + nodesCount + ", " + (System.currentTimeMillis() - startTime) + "ms");
  }


}
