/**
 * Copyright 2001-2003 The eXo platform SARL All rights reserved.
 * Please look at license.txt in info directory for more license detail.
 **/

package org.exoplatform.services.jcr.impl.core;


import javax.jcr.Node;
import javax.jcr.Session;

import org.exoplatform.services.jcr.JcrImplBaseTest;
import org.exoplatform.services.jcr.RepositoryService;

/**
 * Created by The eXo Platform SARL        .
 *
 * @author <a href="mailto:geaz@users.sourceforge.net">Gennady Azarenkov</a>
 * @version $Id: TestWeakHashMap.java 5150 2006-04-17 06:44:21Z geaz $
 */
public class TestInitRepository extends JcrImplBaseTest {

  public void setUp() throws Exception {
      super.setUp();
  }

/*
  public void testRepositoryServiceRegistration() throws Exception {
  	
  	RepositoryService service = (RepositoryService)container.getComponentInstanceOfType(RepositoryService.class);
  	assertNotNull(service);
  	
  	RepositoryImpl defRep = (RepositoryImpl)service.getRepository();
  	assertNotNull(defRep);
  	
  	String sysWs = defRep.getSystemWorkspaceName();
  	assertFalse("Sys ws should not be initialized for this test!!", defRep.isWorkspaceInitialized(sysWs));
  	
  	// Default Namespaces and NodeTypes
  	NamespaceRegistry nsReg = defRep.getNamespaceRegistry();
  	assertNotNull(nsReg);
  	assertTrue(nsReg.getPrefixes().length>0);
  	
  	NodeTypeManager ntReg = defRep.getNodeTypeManager();
  	assertNotNull(ntReg);
  	assertTrue(ntReg.getAllNodeTypes().getSize()>0);
  	

  }
*/
  public void testInitSystemWorkspace() throws Exception {
  	
  	RepositoryService service = (RepositoryService)container.getComponentInstanceOfType(RepositoryService.class);
  	RepositoryImpl defRep = (RepositoryImpl)service.getRepository();
  	String sysWs = defRep.getSystemWorkspaceName();
  	assertFalse("Sys ws should not be initialized for this test!!", defRep.isWorkspaceInitialized(sysWs));

  	defRep.initWorkspace(sysWs, "nt:unstructured");
  	
  	Session sess = defRep.getSystemSession(sysWs);
  	
  	Node root = sess.getRootNode();
  	assertNotNull(root);
  	
  	assertNotNull(root.getNode("jcr:system"));
  	
  	assertNotNull(root.getNode("jcr:system/exo:namespaces"));
  	
  }

  public void testInitRegularWorkspace() throws Exception {
  	
  	RepositoryService service = (RepositoryService)container.getComponentInstanceOfType(RepositoryService.class);
  	RepositoryImpl defRep = (RepositoryImpl)service.getRepository();
  	String sysWs = defRep.getSystemWorkspaceName();

  	String[] names = defRep.getWorkspaceNames();
  	String wsName = null;
  	for(int i=0; i<names.length; i++) {
  		if(!names[i].equals(sysWs)) {
  			wsName = names[i];
  			break;
  		}
  	}
  	if(wsName == null)	
  	   fail("not system workspace not found for test!!");

  	defRep.initWorkspace(wsName, "nt:unstructured");
  	
//  	Session sysSess = defRep.getSystemSession(sysWs);
  	Session sess = defRep.getSystemSession(wsName);
  	//  	assertEquals(sysSess, sess);
//  	log.info("sys>>"+sysWs+" "+sysSess);
  	log.info("reg>>"+wsName+" "+sess);
  	
  	Node root = sess.getRootNode();
  	assertNotNull(root);
  	
//  	root = sysSess.getRootNode();
//  	assertNotNull(root);

  }
}
