package org.exoplatform.services.webdav.commands;

import org.apache.commons.chain.Context;
import org.exoplatform.services.webdav.DavConst;
import org.exoplatform.services.webdav.DavSession;
import org.exoplatform.services.webdav.structs.DavFileInfo;

public class DavGet extends DavCommand {

  public DavGet() {
    super();
    needSrcSession = false;
  }
  
//  @Override
//  public final boolean execute(Context context) throws Exception {
//    try {
//      DelTest test = new DelTest(davService.getRepositoryService().getRepository());
//    } catch (Exception exc) {
//      System.out.println("Can't start testts");
//    }
//    return false;
//  }
  
  @Override
  protected boolean process() {
    DavFileInfo resInfo = null;
    if ("".equals(davContext.getSrcWorkspace())) {
      resInfo = new DavFileInfo();
      resInfo.setInputStream(davService.getHtmlWorkspaces(
          davContext.getServerPrefix(),
          davContext.getServerApp()));      
    } else {
      srcSession = davContext.getSourceSession(davService.getSessionProvider(), davService.getConfig());
      if (srcSession == null) {
        String defAuthHeader = davService.getConfig().getAuthHeader();
        davContext.answerAuthNeeded(defAuthHeader);
        return false;
      }
      resInfo = srcSession.getFile();
    }

    if (resInfo == null || resInfo.getInputStream() == null) {
      davContext.answerNotFound();
      return false;
    }
    
    if (resInfo.getContentType() != null) {
      davContext.setResponseHeader(DavConst.Headers.CONTENTTYPE, resInfo.getContentType());
    }
    if (resInfo.getLastModified() != null) {
      davContext.setResponseHeader(DavConst.Headers.LASTMODIFIED, resInfo.getLastModified());
    }
    int contentLength = resInfo.getContentLength();
    davContext.setResponseHeader(DavConst.Headers.CONTENTLENGTH, String.format("%s", contentLength));
    
    davContext.answerOk();
    
    try {
      byte []buff = new byte[4096];
      int res = 0;
      while ((res = resInfo.getInputStream().read(buff)) > 0) {
        davContext.writeToResponse(buff, res);
      }
    } catch (Exception exc) {
      exc.printStackTrace();
      return false;
    }
    
    return true;    
  }  
  
}
