package org.exoplatform.services.webdav.commands;

import org.exoplatform.services.webdav.DavConst;
import org.exoplatform.services.webdav.structs.DavFileInfo;

public class DavHead extends DavCommand {

  protected boolean process() {
    
    DavFileInfo resInfo = srcSession.getResourceHeader();
    if (resInfo == null) {
      davContext.answerNotFound();
      return false;
    }
    
    davContext.setResponseHeader(DavConst.Headers.LASTMODIFIED, resInfo.getLastModified());
    davContext.setResponseHeader(DavConst.Headers.CONTENTTYPE, resInfo.getContentType());
    if (!resInfo.isCollection()) {
      davContext.setResponseHeader(DavConst.Headers.CONTENTLENGTH, String.format("%s", resInfo.getContentLength()));
    }
    davContext.answerOk();
    return true;    
  }  

}
