package org.exoplatform.services.webdav.commands;

import javax.jcr.lock.Lock;

import org.exoplatform.services.webdav.DavConst;
import org.exoplatform.services.webdav.props.LockDiscoveryProp;
import org.exoplatform.services.webdav.request.RequestDocApi;

public class DavLock extends DavCommand {

  protected boolean process() {
    RequestDocApi requestDoc = davContext.getDocumentFromRequest();
    Lock lockResult = srcSession.tryLock(requestDoc);
    
    if (lockResult == null) {
      davContext.answerPreconditionFailed();
      return false;
    }
    
    LockDiscoveryProp lockDiscovery = srcSession.getLockDiscovery();
    if (lockDiscovery == null) {
      davContext.answerOk();
    } else {
      lockDiscovery.setLockToken(lockResult.getLockToken());
      davContext.setResponseHeader(DavConst.Headers.LOCKTOKEN, "<" + lockResult.getLockToken() + ">");
      davContext.answerProperty(lockDiscovery);
    }
    
    return true;    
  }
  
}
