package org.exoplatform.services.webdav.commands;

import java.util.ArrayList;
import org.exoplatform.services.webdav.DavConst;

public class DavOptions extends DavCommand {

  public DavOptions() {
    super();
    needSrcSession = false;
  }

  protected boolean process() {    
    String allowedCommands = "";
    
    ArrayList<String> availableCommands = davService.getAvailableCommands();
    for (int i = 0; i < availableCommands.size(); i++) {
      String curCommand = availableCommands.get(i);
      allowedCommands += curCommand;
      if (i < (availableCommands.size() - 1)) {
        allowedCommands += ", ";
      }
    }
    
    davContext.setResponseHeader(DavConst.Headers.ALLOW, allowedCommands);
    davContext.setResponseHeader(DavConst.Headers.DAV, DavConst.DAV_VERSIONS);
    davContext.setResponseHeader(DavConst.Headers.MSAUTHORVIA, DavConst.DAV_MSAUTHORVIA);    
    davContext.answerOk();       
    return true;    
  }  

}
