package org.exoplatform.services.webdav.commands;

import org.exoplatform.services.webdav.request.RequestDocApi;
import org.exoplatform.services.webdav.structs.DMultistatus;

public class DavPropfind  extends DavCommand {

  public DavPropfind() {
    super();
    needSrcSession = false;
  }
  
  protected boolean process() {
    RequestDocApi requestDoc = davContext.getDocumentFromRequest();

    DMultistatus multistatus = null;
    if ("".equals(davContext.getSrcWorkspace())) {
      multistatus = davService.getPresetWorkspaces(davContext.getServerPrefix(), requestDoc);
    } else {
      srcSession = davContext.getSourceSession(davService.getSessionProvider(), davService.getConfig());
      if (srcSession == null) {
        String defAuthHeader = davService.getConfig().getAuthHeader();
        davContext.answerAuthNeeded(defAuthHeader);
        return false;
      }
      multistatus = srcSession.getProperties(requestDoc);
    }
    
    if (multistatus == null) {
      davContext.answerNotFound();
      return false;
    }
    
    davContext.answerMultistatus(multistatus);    
    return true;    
  }

}
