package org.exoplatform.services.webdav.commands;

import java.io.ByteArrayInputStream;
import java.io.InputStream;

import org.apache.commons.logging.Log;
import org.exoplatform.services.log.ExoLogger;

public class DavPut extends DavCommand {
  
  private static Log log = ExoLogger.getLogger("jcr.DavPut");

  protected boolean process() {
    try {
      InputStream inStream = davContext.getRequestStream();
      
      if (inStream == null) {
        davContext.answerPreconditionFailed();
        return false;
      }
      
      boolean created = srcSession.createFile(inStream);
      if (!created) {
        davContext.answerForbidden();
      } else {
        davContext.answerCreated();
      }
      return created;
      
    } catch (Throwable exc) {
      log.info("Unhandled exception. " + exc.getMessage(), exc);
    }
    return false;
  }
  
}
