package org.exoplatform.services.webdav.props;

import javax.jcr.Node;
import javax.jcr.version.Version;
import javax.jcr.version.VersionHistory;

import org.apache.commons.logging.Log;
import org.exoplatform.services.log.ExoLogger;
import org.exoplatform.services.webdav.DavConst;
import org.exoplatform.services.webdav.DavConst.DavProperty;
import org.exoplatform.services.webdav.DavConst.NodeTypes;
import org.exoplatform.services.webdav.commands.DavReport;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

public class CheckedInProp extends CommonProp {

  private static Log log = ExoLogger.getLogger("jcr.CheckedInProp");
  protected String lastVersionHref = "";
  
  public CheckedInProp() {
    super(DavConst.DavProperty.CHECKEDIN);
  }

  @Override
  public boolean fillFromNode(Node node, String href) {
    try {
      if (node instanceof Version) {
        lastVersionHref = href + DavConst.DAV_VERSIONPREFIX + node.getName();
        status = DavConst.HttpStatus.OK;
        return true;        
      }
      
      if (!node.isNodeType(DavConst.NodeTypes.MIX_VERSIONABLE)) {
        return false;
      }
      if (node.isCheckedOut()) {
        return false;
      }
      
      lastVersionHref = href + DavConst.DAV_VERSIONPREFIX + node.getBaseVersion().getName();
      status = DavConst.HttpStatus.OK;
      return true;
    } catch (Exception exc) {
      log.info("Uhandled exception. " + exc.getMessage());
      exc.printStackTrace();
    }
    return false;
  }
  
  @Override
  public void toXml(Document rootDoc, Element parentElement) {
    super.toXml(rootDoc, parentElement);
    if (status != DavConst.HttpStatus.OK) {
      return;
    }
    
    Element elHref = rootDoc.createElement(DavConst.DAV_PREFIX + DavConst.DavProperty.HREF);
    propertyElement.appendChild(elHref);
    elHref.setTextContent(lastVersionHref);
  }
  
}
