package org.exoplatform.services.webdav.props;

import javax.jcr.Node;

import org.apache.commons.logging.Log;
import org.exoplatform.services.log.ExoLogger;
import org.exoplatform.services.webdav.DavConst;
import org.exoplatform.services.webdav.DavConst.NodeTypes;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

public class CheckedOutProp extends CommonProp {

  private static Log log = ExoLogger.getLogger("jcr.CheckedOutProp");
  
  public CheckedOutProp() {
    super(DavConst.DavProperty.CHECKEDOUT);
  }

  @Override
  public boolean fillFromNode(Node node, String href) {
    try {
      if (!node.isNodeType(DavConst.NodeTypes.MIX_VERSIONABLE)) {
        return false;
      }
      if (!node.isCheckedOut()) {
        return false;
      }
      status = DavConst.HttpStatus.OK;
      return true;
    } catch (Exception exc) {
      log.info("Unhandled exception. " + exc.getMessage());
      exc.printStackTrace();
    }
    
    return false;
  }  
  
  @Override
  public void toXml(Document rootDoc, Element parentElement) {
    super.toXml(rootDoc, parentElement);
  }
  
}
