package org.exoplatform.services.webdav.props;

import javax.jcr.Node;

import org.apache.commons.logging.Log;
import org.exoplatform.services.log.ExoLogger;
import org.exoplatform.services.webdav.DavConst;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

public class CommonProp implements PropApi {

  private static Log log = ExoLogger.getLogger("jcr.CommonProp");
  protected String propertyName = "";
  protected String defaultStringValue = "";
  protected int status = DavConst.HttpStatus.NOTFOUND;
  protected Element propertyElement = null;
  
  public CommonProp() {
  }
  
  public CommonProp(String propertyName) {
    this.propertyName = propertyName;
  }
  
  public void setStatus(int status) {
    this.status = status;
  }
  
  public int getStatus() {
    return status;
  }
  
  public String getName() {
    return propertyName;
  }

  public void setDefaultStringValue(String defaultStringValue) {
    this.defaultStringValue = defaultStringValue;
  }
  
  public String getDefaultStringValue() {
    return defaultStringValue;
  }
  
  public boolean fillFromNode(Node node, String href) {
    return false;
  }    
  
  public void toXml(Document rootDoc, Element parentElement) {
    propertyElement = rootDoc.createElement(DavConst.DAV_PREFIX + propertyName);
    parentElement.appendChild(propertyElement);
    if (DavConst.HttpStatus.OK != status) {
      return;
    }
    if (!"".equals(defaultStringValue)) {
      propertyElement.setTextContent(defaultStringValue);
    }
  }
  
}
