package org.exoplatform.services.webdav.props;

import javax.jcr.Node;

import org.apache.commons.logging.Log;
import org.exoplatform.services.log.ExoLogger;
import org.exoplatform.services.webdav.DavConst;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

public class ContentTypeProp extends CommonProp {

  private static Log log = ExoLogger.getLogger("jcr.ContentTypeProp");
  protected String mimeType = "";
  
  public ContentTypeProp() {
    super(DavConst.DavProperty.GETCONTENTTYPE);
  }
  
  @Override
  public boolean fillFromNode(Node node, String href) {
    try {
      if (!node.isNodeType(DavConst.NodeTypes.NT_FILE)) {
        return false;
      }      
      if (!node.hasNode(DavConst.NodeTypes.JCR_CONTENT)) {
        return false;
      }

      Node contentNode = node.getNode(DavConst.NodeTypes.JCR_CONTENT);
      if (!contentNode.hasProperty(DavConst.NodeTypes.JCR_MIMETYPE)) {
        return false;
      }      
      mimeType = contentNode.getProperty(DavConst.NodeTypes.JCR_MIMETYPE).getString();
      status = DavConst.HttpStatus.OK;
      return true;
    } catch (Exception exc) {
      log.info("Unhaldled exception. " + exc.getMessage());
      exc.printStackTrace();
    }
    
    return false;
  }  
  
  @Override
  public void toXml(Document rootDoc, Element parentElement) {
    super.toXml(rootDoc, parentElement);
    if (status != DavConst.HttpStatus.OK) {
      return;
    }
    propertyElement.setTextContent(mimeType);
  }
  
}
