package org.exoplatform.services.webdav.request;

import java.util.ArrayList;

import org.apache.commons.logging.Log;
import org.exoplatform.services.log.ExoLogger;
import org.exoplatform.services.webdav.DavConst;
import org.exoplatform.services.webdav.DavUtil;
import org.w3c.dom.Document;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

public class VersionTreeDoc extends CommonPropDoc {
  
  private static Log log = ExoLogger.getLogger("jcr.VersionTreeDoc");
  
  public VersionTreeDoc() {
  }

  @Override
  public boolean initFromDocument(Document requestDocument) {
    try {
      Node versionTree = DavUtil.getChildNode(requestDocument, DavConst.DavDocument.VERSIONTREE);
      Node props = DavUtil.getChildNode(versionTree, DavConst.DavProperty.PROP);
      NodeList nodes = props.getChildNodes();

      for (int i = 0; i < nodes.getLength(); i++) {
        Node curPropertyNode = nodes.item(i);
        String localName = curPropertyNode.getLocalName();
        if (localName != null && DavConst.DAV_NAMESPACE.equals(curPropertyNode.getNamespaceURI())) {
          addProperty(localName);
        }      
      }    
      return true;
    } catch (Exception exc) {
      log.info("Can't fill document data. " + exc.getMessage());
      exc.printStackTrace();      
    }    
    return false; 
  }
  
}
