package org.exoplatform.services.webdav.structs;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

import org.apache.commons.logging.Log;
import org.exoplatform.services.log.ExoLogger;
import org.exoplatform.services.webdav.DavConst;
import org.exoplatform.services.webdav.DavUtil;
import org.exoplatform.services.webdav.props.PropApi;

public class DResponse {
  
  private static Log log = ExoLogger.getLogger("jcr.DavResponse");

  public DResponse() {
  }
  
  private String href = "";
  private ArrayList<PropApi> propertyes = new ArrayList<PropApi>();
    
  public void setHref(String href) {
    this.href = href;
  }
  
  public String getHref() {
    return href;
  }
  
  public void AddProperty(PropApi property) {
    propertyes.add(property);
  }
  
  public void toXml(Document rootDoc, Element multistatusElement) {
    Element response = rootDoc.createElement(DavConst.DAV_PREFIX + DavConst.DavProperty.RESPONSE);
    multistatusElement.appendChild(response);
    
    Element hrefElement = rootDoc.createElement(DavConst.DAV_PREFIX + DavConst.DavProperty.HREF);
    response.appendChild(hrefElement);
    hrefElement.setTextContent(href);
    
    HashMap<Integer, ArrayList<PropApi>> propStatusGroups = new HashMap<Integer, ArrayList<PropApi>>();
    
    for (PropApi curProp : propertyes) {
      int curPropStat = curProp.getStatus();
      ArrayList<PropApi> propGroup = (ArrayList<PropApi>)propStatusGroups.get(curPropStat);
      if (propGroup == null) {
        propGroup = new ArrayList<PropApi>();
        propStatusGroups.put(new Integer(curPropStat), propGroup);
      }
      propGroup.add(curProp);
    }

    Iterator<Integer> groupStatusIter = propStatusGroups.keySet().iterator();
    while (groupStatusIter.hasNext()) {
      Integer curStatus = groupStatusIter.next();
      
      Element propStat = rootDoc.createElement(DavConst.DAV_PREFIX + DavConst.DavProperty.PROPSTAT);
      response.appendChild(propStat);
      
      Element prop = rootDoc.createElement(DavConst.DAV_PREFIX + DavConst.DavProperty.PROP);
      propStat.appendChild(prop);
      
      ArrayList<PropApi> propList = propStatusGroups.get(curStatus);
      for (int i = 0; i < propList.size(); i++) {
        PropApi curProp = propList.get(i);
        curProp.toXml(rootDoc, prop);
      }
      
      Element status = rootDoc.createElement(DavConst.DAV_PREFIX + DavConst.DavProperty.STATUS);
      propStat.appendChild(status);
      status.setTextContent(DavUtil.GetStatusInfo(curStatus));
    }
    
  }
  
}
