/**
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 */

package org.exoplatform.services.jcr.dataflow.persistent;

import org.exoplatform.services.jcr.access.AccessControlList;
import org.exoplatform.services.jcr.datamodel.ImmutableItemData;
import org.exoplatform.services.jcr.datamodel.InternalQPath;
import org.exoplatform.services.jcr.datamodel.ItemData;

/**
 * Created by The eXo Platform SARL        . </br>
 * 
 * Immutable ItemData from persisten storage
 * 
 * @author <a href="mailto:gennady.azarenkov@exoplatform.com">Gennady Azarenkov</a>
 * @version $Id: PersistedItemData.java 5237 2006-04-25 09:49:05Z peterit $
 */

public abstract class PersistedItemData implements ImmutableItemData {
  
  protected final String id;
  protected final InternalQPath qpath;
  protected final String parentId; 
  protected final int version;
  protected final AccessControlList acl;
  
  public PersistedItemData(String id, InternalQPath qpath, String parentId, int version, AccessControlList acl) {
    this.id = id;
    this.qpath = qpath;
    this.parentId = parentId;
    this.version = version;
    this.acl = acl;
  }

  public InternalQPath getQPath() {
    return qpath;
  }

  public String getUUID() {
    return id;
  }

  public int getPersistedVersion() {
    return version;
  }

  public String getParentUUID() {
    return parentId;
  }
  
  // TODO
  public AccessControlList getACL() {
    return acl;
  }
  
  @Override
  public boolean equals(Object obj) {
    if (obj instanceof ItemData) {
      return getUUID().equals(((ItemData) obj).getUUID());
    } else {
      return false;
    }
  }  
}
