/**
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 */

package org.exoplatform.services.jcr.dataflow.persistent;

import org.exoplatform.services.jcr.datamodel.ValueData;
/**
 * Created by The eXo Platform SARL        .</br>
 * 
 * Immutable PropertyData
 * 
 * @author <a href="mailto:gennady.azarenkov@exoplatform.com">Gennady Azarenkov</a>
 * @version $Id: PersistedValueData.java 5185 2006-04-19 09:03:04Z peterit $
 */

public class PersistedValueData implements ValueData {
  
  protected final byte[] data;
  protected int orderNumber; // [PN] final removed
  
  public PersistedValueData(byte[] data, int orderNumber) {
    this.data = data;
    this.orderNumber = orderNumber;
  }

  public byte[] getAsByteArray() {
    return data;
  }
  
  public int getOrderNumber() {
    return orderNumber;
  }

  public void setOrderNumber(int orderNum) {
    // [PN] 19.04.06 It's used in session runtime (PropertyImpl.doSetValue())
    //throw new RuntimeException("DO NOT call setOrderNumber! ");
    this.orderNumber = orderNum;
  }
}
