/**
 * Copyright 2001-2006 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 */

package org.exoplatform.services.jcr.storage.value;

import java.io.IOException;
import java.util.List;
import java.util.Properties;

import org.exoplatform.services.jcr.storage.DataContainer;

/**
 * Created by The eXo Platform SARL        .
 * @author Gennady Azarenkov
 * @version $Id: $
 */

public interface ValueStoragePlugin extends DataContainer {
  
  /**
   * opens ValueIOChannel
   * @return the channel
   * @throws IOException
   */
  ValueIOChannel openIOChannel() throws IOException;
  
  /**
   * @return filters applicable to this plugin
   */
  List <ValuePluginFilter> getFilters();
  
  /**
   * initializes the plugin
   * @param props
   * @param filters
   * @throws IOException
   */
  void init(Properties props, List <ValuePluginFilter> filters) throws IOException;

}
