/**
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 */

package org.exoplatform.services.jcr.impl.core;

import org.exoplatform.services.jcr.datamodel.ItemData;

/**
 * Created by The eXo Platform SARL        .
 * @author <a href="mailto:gennady.azarenkov@exoplatform.com">Gennady Azarenkov</a>
 * @version $Id: ItemState.java 7271 2006-07-21 11:58:01Z peterit $
 */

public class ItemState {
  
  private ItemData data;
  private int state;
  private ItemData parentData;
  
  public ItemState(ItemData data, int state) {
    this.data = data;
    this.state = state;  
  }
  
  public ItemState(ItemData data, int state, ItemData parentData) {
    this.data = data;
    this.state = state;
    this.parentData = parentData;
  }

  /**
   * @return Returns the data.
   */
  public ItemData getData() {
    return data;
  }
  
  /**
   * @return Returns the state.
   */
  public int getState() {
    return state;
  }
  
  public boolean isNode() {
    return data.isNode();
  }
  
  public static ItemState createAdded(ItemData data) {
    return new ItemState(data, ItemChangeState.ADDED); 
  }
  
  public static ItemState createUpdated(ItemData data) {
    return new ItemState(data, ItemChangeState.UPDATED); 
  }

  public static ItemState createDeleted(ItemData data) {
    return new ItemState(data, ItemChangeState.DELETED); 
  }

  /**
   * Returns a parent of item. 
   * */
  public ItemData getParentData() {
    return parentData;
  }

}
