/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/

package org.exoplatform.services.jcr.impl.core.nodetype;

import javax.jcr.nodetype.ItemDefinition;
import javax.jcr.nodetype.NodeType;

/**
 * Created by The eXo Platform SARL        .
 *
 * @author <a href="mailto:geaz@users.sourceforge.net">Gennady Azarenkov</a>
 * @version $Id: ItemDefinitionImpl.java 5150 2006-04-17 06:44:21Z geaz $
 */

public abstract class ItemDefinitionImpl implements ItemDefinition {

    public static String RESIDUAL_SET = "*";

	protected NodeType declaringNodeType;
	
	protected String name;

	protected boolean autoCreate;

	protected int onVersion;

	protected boolean readOnly;

	protected boolean mandatory;

	/**
	 * @see javax.jcr.nodetype.ItemDef#getName
	 */
	public String getName() {
		return name;
	}

	/**
	 * @see javax.jcr.nodetype.ItemDef#isAutoCreate
	 */
	public boolean isAutoCreated() {
		return autoCreate;
	}

	/**
	 * @see javax.jcr.nodetype.ItemDef#getOnParentVersion
	 */
	public int getOnParentVersion() {
		return onVersion;
	}

	/**
	 * @see javax.jcr.nodetype.ItemDef#isProtected
	 */
	public boolean isProtected() {
		return readOnly;
	}

	/**
	 * @see javax.jcr.nodetype.ItemDef#isMandatory
	 */
	public boolean isMandatory() {
		return mandatory;
	}

	/**
	 * @see javax.jcr.nodetype.ItemDef#getDeclaringNodeType
	 */
	public NodeType getDeclaringNodeType() {
		return declaringNodeType;
	}

	//////////////////////////////////////////////

	public boolean isResidualSet() {
		return this.name.equals(RESIDUAL_SET);
	}

	/**
	 * @param autoCreate
	 *            The autoCreate to set.
	 */
	public void setAutoCreate(boolean autoCreate) {
		this.autoCreate = autoCreate;
	}

	/**
	 * @param declaringNodeType
	 *            The declaringNodeType to set.
	 */
	public void setDeclaringNodeType(NodeType declaringNodeType) {
		this.declaringNodeType = declaringNodeType;
	}

	/**
	 * @param mandatory
	 *            The mandatory to set.
	 */
	public void setMandatory(boolean mandatory) {
		this.mandatory = mandatory;
	}

	/**
	 * @param name
	 *            The name to set.
	 */
	public void setName(String name) {
		this.name = name;
	}

	/**
	 * @param onVersion
	 *            The onVersion to set.
	 */
	public void setOnVersion(int onVersion) {
		this.onVersion = onVersion;
	}

	/**
	 * @param readOnly
	 *            The readOnly to set.
	 */
	public void setReadOnly(boolean readOnly) {
		this.readOnly = readOnly;
	}
}
