/***************************************************************************
 * Copyright 2001-2006 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.jcr.api.lock;

import javax.jcr.Node;
import javax.jcr.RepositoryException;

import org.exoplatform.services.jcr.JcrAPIBaseTest;

/**
 * Created by The eXo Platform SARL
 * Author : Peter Nedonosko
 *          peter.nedonosko@exoplatform.com.ua
 * 21.09.2006
 * @author <a href="mailto:peter.nedonosko@exoplatform.com.ua">Peter Nedonosko</a>
 * @version $Id: TestLock.java 9155 2006-09-27 09:02:21Z peterit $
 */
public class TestLock extends JcrAPIBaseTest {

  private Node lockedNode = null;
  
  public void setUp() throws Exception {
    
    super.setUp();
    
    try {
      lockedNode = root.addNode("locked node");
      if (lockedNode.canAddMixin("mix:lockable"))
        lockedNode.addMixin("mix:lockable");
      root.save();
    } catch (RepositoryException e) {
      fail("Child node must be accessible and readable. But error occurs: " + e);
    }
  }

  public void testLockByOwner() throws RepositoryException {

    try {
      lockedNode.lock(true, true);
      Node foo = lockedNode.addNode("foo");
      foo.addNode("bar"); // throws LockException "Node /node/foo is locked"
      lockedNode.save();
    } catch (RepositoryException e) {
      fail("Child node must be accessible and readable. But error occurs: " + e);
    }
    
    try {
      lockedNode.unlock();
      lockedNode.addNode("foo");
      session.save();
      lockedNode.lock(true, true);
      lockedNode.getNode("foo").addNode("bar"); // throws LockException "Node /node/foo is locked"
      lockedNode.save();
    } catch (RepositoryException e) {
      fail("Child node must be accessible and readable. But error occurs: " + e);
    }
    
    try {
      lockedNode.unlock();
      lockedNode.addNode("foo");
      session.save();
      lockedNode.lock(true, true);
      lockedNode.getNode("foo").setProperty("bar", "bar"); // throws LockException "Node /node/foo is locked"
      lockedNode.save();
      lockedNode.unlock();
    } catch (RepositoryException e) {
      fail("Child node must be accessible and readable. But error occurs: " + e);
    }
  }
}
